import { ObjectUpdateType } from '../../../../../ObjectUpdateType';
import { Primitive } from '../../../../../Primitive';
import { System } from '../../../../../system';
import { J } from '../../../../../types/interface/J';
import { V } from '../../../../../types/interface/V';
import { Unlisten } from '../../../../../types/Unlisten';
export type I = {};
export type O = {};
export default class SessionStorage extends Primitive<I, O> implements V, J {
    constructor(system: System);
    private _checkAPI;
    read(): Promise<any>;
    write(data: any): Promise<void>;
    get(name: string): Promise<any>;
    set(name: string, data: any): Promise<void>;
    delete(name: string): Promise<any>;
    deepSet(path: string[], data: any): Promise<void>;
    deepGet(path: string[]): Promise<any>;
    deepDelete(path: string[]): Promise<void>;
    subscribe(path: string[], key: string, listener: (type: ObjectUpdateType, path: string[], key: string, data: any) => void): Unlisten;
    keys(): Promise<string[]>;
    hasKey(name: string): Promise<boolean>;
}
